{ 010429-1.PAS                                                              }
{ 2001-04-29 programmeerimisolmpiaadi 1. lesande lahendus                 }
{    KEELATUD SNE                                                          }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 1.04/GO32V2                                         }

const
   maxn = 200;
   maxp = 350; { log(52)*maxn }
   sisf = 'keelat.sis';
   valf = 'keelat.val';

type
   arv = array [0..maxp] of byte;
   parv = ^arv;
   marv = array [0..maxn] of parv;

{ x := z }
procedure omistav (var x : arv; z : integer);
var i : integer;
begin
   for i := 0 to maxp do begin
      x[i] := z mod 10;
      z := z div 10;
   end;
end;

{ x := y }
procedure omistas (var x, y : arv);
var i : integer;
begin
   for i := 0 to maxp do
      x[i] := y[i];
end;

{ x := x + y }
procedure liidas (var x, y : arv);
var i, z : integer;
begin
   z := 0;
   for i := 0 to maxp do begin
      z := z + x[i] + y[i];
      x[i] := z mod 10;
      z := z div 10;
   end;
end;

{ x := x - y }
procedure lahutas (var x, y : arv);
var i, z : integer;
begin
   z := 0;
   for i := 0 to maxp do begin
      z := z + x[i] - y[i];
      if z < 0 then begin
         x[i] := 10 + z;
         z := -1;
      end else begin
         x[i] := z;
         z := 0;
      end;
   end;
end;

{ x := k * x }
procedure korrutav (var x : arv; k : integer);
var i, z : integer;
begin
   z := 0;
   for i := 0 to maxp do begin
      z := z + k * x[i];
      x[i] := z mod 10;
      z := z div 10;
   end;
end;

procedure truki (var f : text; var x : arv);
var i : integer; z : boolean;
begin
   z := false;
   for i := maxp downto 1 do begin
      if x[i] > 0 then
         z := true;
      if z then
         write (f, x[i]);
   end;
   writeln (f, x[0]);
end;

var
   t : integer;
   n : integer;
   s : string;
   f : text;

var
   skoht : array [1..maxn] of boolean;
   sufiks : marv;
   infiks : marv;
   summa : arv;
   i, j : integer;

procedure arvuta_skoht (var s : string);
var a : array [1..maxn] of integer; i, k : integer;
begin
   a[1] := 0;
   for i := 2 to length (s) do begin
      k := i - 1;
      while (k > 0) and (s[i] <> s[a[k] + 1]) do
         k := a[k];
      if k > 0 then
         a[i] := a[k] + 1
      else if s[i] = s[1] then
         a[i] := 1
      else
         a[i] := 0;
   end;
   for i := 1 to length (s) do
      skoht[i] := false;
   k := a[length (s)];
   while k > 0 do begin
      skoht[k] := true;
      k := a[k];
   end;
end;

begin
   assign (f, sisf); reset (f);
   readln (f, s); t := length (s);
   readln (f, n);
   readln (f, s);
   close (f);

   arvuta_skoht (s);
   for i := 0 to n do begin
     new (sufiks[i]);
     new (infiks[i]);
   end;
   for i := 0 to length (s) - 1 do begin
      omistav (sufiks[i]^, 0);
      omistav (infiks[i]^, 0);
   end;
   omistav (sufiks[length (s)]^, 1);
   omistav (infiks[length (s)]^, 1);
   omistav (summa, 1);
   for i := length (s) + 1 to n do begin
      korrutav (summa, t);
      omistas (sufiks[i]^, summa);
      lahutas (sufiks[i]^, infiks[i - length(s)]^);
      for j := 1 to length(s) - 1 do
         if skoht[j] then
            lahutas (sufiks[i]^, sufiks[i + j - length (s)]^);
      omistas (infiks[i]^, infiks[i - 1]^);
      korrutav (infiks[i]^, t);
      liidas (infiks[i]^, sufiks[i]^);
   end;
   omistav (summa, 1);
   for i := 1 to n do
      korrutav (summa, t);
   lahutas (summa, infiks[n]^);

   if length (s) = 0 then
      omistav (summa, 0);

   for i := 0 to n do begin
      dispose (sufiks[i]);
      dispose (infiks[i]);
   end;

   assign (f, valf); rewrite (f);
   truki (f, summa);
   close (f);
end.
